USE MIMOSA_CRIS_V3_2;
GO
WITH SegmentTypeChildren (user_var, name_var, key1, key2, key3, level_var, sort_var)
AS
(
-- Anchor member definition
    SELECT DISTINCT sgt1.user_tag_ident, sgt1.name, stc1.sg_db_site, stc1.sg_db_id, stc1.sg_type_code, 0, cast(sgt1.user_tag_ident as varchar(255)) 
    FROM segment_type_child AS stc1
    INNER JOIN segment_type as sgt1
        ON sgt1.sg_db_site = stc1.sg_db_site AND
           sgt1.sg_db_id = stc1.sg_db_id AND
		   sgt1.sg_type_code = stc1.sg_type_code
    LEFT OUTER JOIN segment_type_child AS stc2
        ON stc2.child_sg_db_site = stc1.sg_db_site AND
           stc2.child_sg_db_id = stc1.sg_db_id AND
		   stc2.child_sg_type_code = stc1.sg_type_code
    WHERE  stc2.child_sg_db_site IS NULL AND
           stc1.rstat_type_code = 1 AND
           sgt1.sg_db_site='0000000000000000'
UNION ALL
-- Recursive member definition
   SELECT sgt2.user_tag_ident, sgt2.name, stc3.child_sg_db_site, stc3.child_sg_db_id, stc3.child_sg_type_code,
			stc4.level_var + 1, cast((stc4.sort_var+'\'+sgt2.user_tag_ident+'\'+stc3.child_sg_db_site+'.'+LTRIM(STR(stc3.child_sg_db_id))+'.'+LTRIM(STR(stc3.child_sg_type_code))) as varchar(255))
    FROM segment_type_child AS stc3
    INNER JOIN segment_type as sgt2
        ON sgt2.sg_db_site = stc3.sg_db_site AND
           sgt2.sg_db_id = stc3.sg_db_id AND
	       sgt2.sg_type_code = stc3.sg_type_code
    INNER JOIN SegmentTypeChildren AS stc4
        ON stc3.sg_db_site = stc4.key1 AND
		   stc3.sg_db_id = stc4.key2 AND
		   stc3.sg_type_code = stc4.key3
     WHERE stc3.rstat_type_code = 1 and stc4.level_var < 100 AND
           stc3.sg_db_site='0000000000000000'
)
-- Statement that executes the CTE
SELECT substring('                              ',1,stc5.level_var*2)+sg3.user_tag_ident, sg3.name,
stc5.key1+'.'+LTRIM(STR(stc5.key2))+'.'+LTRIM(STR(stc5.key3)), stc5.key3, stc5.level_var, LTRIM(stc5.sort_var)
FROM SegmentTypeChildren AS stc5
INNER JOIN segment_type as sg3
        ON sg3.sg_db_site = stc5.key1 AND
	       sg3.sg_db_id = stc5.key2 AND
		   sg3.sg_type_code = stc5.key3
ORDER BY stc5.sort_var
GO
